diff --git mkspecs/common/clang-mac.conf mkspecs/common/clang-mac.conf
index 3280274f..38f0bd34 100644
--- mkspecs/common/clang-mac.conf
+++ mkspecs/common/clang-mac.conf
@@ -6,5 +6,8 @@ QMAKE_OBJCXXFLAGS_USE_PRECOMPILE = $$QMAKE_CFLAGS_USE_PRECOMPILE
 
 QMAKE_XCODE_GCC_VERSION = com.apple.compilers.llvm.clang.1_0
 
-QMAKE_CXXFLAGS_CXX11 += -stdlib=libc++
-QMAKE_LFLAGS_CXX11   += -stdlib=libc++
+QMAKE_CXXFLAGS_CXX11 += -stdlib=__MACPORTS_CXX_STDLIB__
+QMAKE_LFLAGS_CXX11   += -stdlib=__MACPORTS_CXX_STDLIB__
+QMAKE_CXXFLAGS       += -stdlib=__MACPORTS_CXX_STDLIB__
+QMAKE_LFLAGS         += -stdlib=__MACPORTS_CXX_STDLIB__
+DEFINES              +=  NS_BUILD_32_LIKE_64
diff --git mkspecs/common/clang.conf mkspecs/common/clang.conf
index d58b44b2..2ad29ef3 100644
--- mkspecs/common/clang.conf
+++ mkspecs/common/clang.conf
@@ -4,8 +4,10 @@
 
 QMAKE_COMPILER          = gcc clang llvm   # clang pretends to be gcc
 
-QMAKE_CC                = clang
-QMAKE_CXX               = clang++
+QMAKE_CC                = __MACPORTS_CC__
+QMAKE_CXX               = __MACPORTS_CXX__
+QMAKE_AR                = @@PREFIX@@/bin/ar cq
+QMAKE_RANLIB            = @@PREFIX@@/bin/ranlib
 
 QMAKE_LINK              = $$QMAKE_CXX
 QMAKE_LINK_SHLIB        = $$QMAKE_CXX
diff --git mkspecs/common/gcc-base.conf mkspecs/common/gcc-base.conf
index fcff502a..8823b1e6 100644
--- mkspecs/common/gcc-base.conf
+++ mkspecs/common/gcc-base.conf
@@ -31,7 +31,7 @@
 # you can use the manual test in tests/manual/mkspecs.
 #
 
-QMAKE_CFLAGS_OPTIMIZE      = -O2
+QMAKE_CFLAGS_OPTIMIZE      = __MACPORTS_OPTFLAGS__
 QMAKE_CFLAGS_OPTIMIZE_FULL = -O3
 
 QMAKE_CFLAGS               += -pipe
diff --git mkspecs/common/macx.conf mkspecs/common/macx.conf
index ad54612f..94a23d4a 100644
--- mkspecs/common/macx.conf
+++ mkspecs/common/macx.conf
@@ -3,6 +3,6 @@
 #
 
 QMAKE_PLATFORM         += osx macx
-QMAKE_MAC_SDK           = macosx
+QMAKE_MAC_SDK           = __MACPORTS_MAC_SDK__
 
 include(mac.conf)
diff --git mkspecs/macx-clang-32/qmake.conf mkspecs/macx-clang-32/qmake.conf
index e0c4bd57..62a7b798 100644
--- mkspecs/macx-clang-32/qmake.conf
+++ mkspecs/macx-clang-32/qmake.conf
@@ -11,7 +11,7 @@ include(../common/gcc-base-mac.conf)
 include(../common/clang.conf)
 include(../common/clang-mac.conf)
 
-QMAKE_MACOSX_DEPLOYMENT_TARGET = 10.6
+QMAKE_MACOSX_DEPLOYMENT_TARGET =  __MACPORTS_DEPLOYMENT_TARGET__
 
 QMAKE_CFLAGS           += -arch i386
 QMAKE_OBJECTIVE_CFLAGS += -arch i386
diff --git mkspecs/macx-clang/qmake.conf mkspecs/macx-clang/qmake.conf
index f28b728b..e4266e91 100644
--- mkspecs/macx-clang/qmake.conf
+++ mkspecs/macx-clang/qmake.conf
@@ -11,6 +11,10 @@ include(../common/gcc-base-mac.conf)
 include(../common/clang.conf)
 include(../common/clang-mac.conf)
 
-QMAKE_MACOSX_DEPLOYMENT_TARGET = 10.6
+QMAKE_MACOSX_DEPLOYMENT_TARGET = __MACPORTS_DEPLOYMENT_TARGET__
+
+QMAKE_CFLAGS           += -arch x86_64
+QMAKE_CXXFLAGS         += -arch x86_64
+QMAKE_LFLAGS           += -arch x86_64
 
 load(qt_config)
diff --git mkspecs/macx-g++-32/qmake.conf mkspecs/macx-g++-32/qmake.conf
index 6ef78aac..01cf5af7 100644
--- mkspecs/macx-g++-32/qmake.conf
+++ mkspecs/macx-g++-32/qmake.conf
@@ -14,7 +14,7 @@ include(../common/macx.conf)
 include(../common/gcc-base-mac.conf)
 include(../common/g++-macx.conf)
 
-QMAKE_MACOSX_DEPLOYMENT_TARGET = 10.6
+QMAKE_MACOSX_DEPLOYMENT_TARGET = __MACPORTS_DEPLOYMENT_TARGET__
 
 QMAKE_CFLAGS           += -arch i386
 QMAKE_OBJECTIVE_CFLAGS += -arch i386
diff --git mkspecs/macx-g++/qmake.conf mkspecs/macx-g++/qmake.conf
index a6c075a2..f507668b 100644
--- mkspecs/macx-g++/qmake.conf
+++ mkspecs/macx-g++/qmake.conf
@@ -14,6 +14,10 @@ include(../common/macx.conf)
 include(../common/gcc-base-mac.conf)
 include(../common/g++-macx.conf)
 
-QMAKE_MACOSX_DEPLOYMENT_TARGET = 10.6
+QMAKE_MACOSX_DEPLOYMENT_TARGET = __MACPORTS_DEPLOYMENT_TARGET__
+
+QMAKE_CFLAGS           += -arch x86_64
+QMAKE_CXXFLAGS         += -arch x86_64
+QMAKE_LFLAGS           += -arch x86_64
 
 load(qt_config)
diff --git mkspecs/macx-g++40/qmake.conf mkspecs/macx-g++40/qmake.conf
index f40315a6..612cfabc 100644
--- mkspecs/macx-g++40/qmake.conf
+++ mkspecs/macx-g++40/qmake.conf
@@ -14,7 +14,7 @@ include(../common/macx.conf)
 include(../common/gcc-base-mac.conf)
 include(../common/g++-macx.conf)
 
-QMAKE_MACOSX_DEPLOYMENT_TARGET = 10.6
+QMAKE_MACOSX_DEPLOYMENT_TARGET = __MACPORTS_DEPLOYMENT_TARGET__
 
 QMAKE_CC                = gcc-4.0
 QMAKE_CXX               = g++-4.0
diff --git mkspecs/macx-g++42/qmake.conf mkspecs/macx-g++42/qmake.conf
index 25383e9c..b21e8617 100644
--- mkspecs/macx-g++42/qmake.conf
+++ mkspecs/macx-g++42/qmake.conf
@@ -14,7 +14,7 @@ include(../common/macx.conf)
 include(../common/gcc-base-mac.conf)
 include(../common/g++-macx.conf)
 
-QMAKE_MACOSX_DEPLOYMENT_TARGET = 10.6
+QMAKE_MACOSX_DEPLOYMENT_TARGET = __MACPORTS_DEPLOYMENT_TARGET__
 
 QMAKE_CC                = gcc-4.2
 QMAKE_CXX               = g++-4.2
diff --git mkspecs/macx-icc/qmake.conf mkspecs/macx-icc/qmake.conf
index 03dc58a6..1eff3a70 100644
--- mkspecs/macx-icc/qmake.conf
+++ mkspecs/macx-icc/qmake.conf
@@ -81,7 +81,7 @@ QMAKE_CXXFLAGS_PRECOMPILE = -c -pch-create ${QMAKE_PCH_OUTPUT} -include ${QMAKE_
 QMAKE_CFLAGS_HIDESYMS   += -fvisibility=hidden
 QMAKE_CXXFLAGS_HIDESYMS += $$QMAKE_CFLAGS_HIDESYMS -fvisibility-inlines-hidden
 
-QMAKE_MACOSX_DEPLOYMENT_TARGET = 10.6
+QMAKE_MACOSX_DEPLOYMENT_TARGET = __MACPORTS_DEPLOYMENT_TARGET__
 
 include(../common/macx.conf)
 
diff --git mkspecs/macx-llvm/qmake.conf mkspecs/macx-llvm/qmake.conf
index 7bdef709..8a9f7684 100644
--- mkspecs/macx-llvm/qmake.conf
+++ mkspecs/macx-llvm/qmake.conf
@@ -14,7 +14,7 @@ include(../common/macx.conf)
 include(../common/gcc-base-mac.conf)
 include(../common/llvm.conf)
 
-QMAKE_MACOSX_DEPLOYMENT_TARGET = 10.6
+QMAKE_MACOSX_DEPLOYMENT_TARGET = __MACPORTS_DEPLOYMENT_TARGET__
 
 QMAKE_XCODE_GCC_VERSION = com.apple.compilers.llvmgcc42
 
